options ls=80;
libname inp 'c:\stats\sas';
title 'Chapter 10 Simulation of AR(1) error';
title2 'Generation of the First estimation sample';
data inp.genauto1;
   u1 = 0;
   do time = -5 to 100;
    u = .5*u1  + rannor(123456);
    y = 10 + .5*time + u;
    if time > 0 then output;
     u1 = u;
   end;
run;



proc print data=genauto1;
run;
symbol1 i=join c=green v=star;
symbol2 i=r c=blue v=none;
proc gplot;
  plot Y*time = 1  Y*time=2/overlay;
run;

proc arima data=genauto1;
i var=u center;
e p=1 printall plot ;
title2 'Check of Autocorrelated error in Original data';
run;

proc autoreg data=genauto1;
   model y = time/nlag=6 method=ml dwprob dw=6 backstep;
   output out=resdat2 r=resid2 ucl=ucl lcl=lcl p=forecast pm=ytrend;
title2 'Autoregression Model of the data';
run;

data resck;
  set resdat2;
title2 'The Residual Data Set';
proc print;
run;

proc arima;
  i var=resid2;
title2 'Check of autocorrelation of residuals of Autoregression';
run;
data together;
  set resdat2;
   if time < 50 then forecast = .;
   if time < 50 then ucl = .;
   if time < 50 then lcl = .;
 run;






/* generates the x-axis value above the reference line */
data anno;
  input time 1-4 text $ 5-58;
function='label'; angle = 90 ; xsys='2'; ysys='1';
x=time; y=60; position='B';
cards;
  50  Forecast begins here
;
axis1 label=(a=90 'Simulated Y(t)');
symbol1 i=join c=blue v=star;
symbol2 i=join c=green v=F;
symbol3 i=join c=black line=1;
symbol4 i=join c=red line=20;
symbol5 i=join c=red line=20;
proc gplot data=together;
  plot (y forecast ytrend lcl ucl) * time/overlay vaxis=axis1 href=50
  annotate=anno;
  where time > 25 & time < 60;
title 'Forecast Profile of Regression with Simulated AR(1) Errors';
title2 'Star=actual data, F=forecast, solid line=trend line ';
title3  'Dotted lines=forecast interval limits';
run;
